Attribute VB_Name = "ProcessUtil"

Option Explicit
'
' WINDOWS NT ONLY
'
Private Declare Function TerminateProcess Lib "kernel32.dll" _
    (ByVal hProcess As Long, ByVal uExitCode As Long) As Long

Private Declare Function CloseHandle Lib "kernel32.dll" _
   (ByVal Handle As Long) As Long

Private Declare Function OpenProcess Lib "kernel32.dll" _
  (ByVal dwDesiredAccessas As Long, ByVal bInheritHandle As Long, _
      ByVal dwProcId As Long) As Long

#If 0 Then
Private Declare Function EnumProcesses Lib "psapi.dll" _
   (ByRef lpidProcess As Long, ByVal cb As Long, _
      ByRef cbNeeded As Long) As Long

Private Declare Function GetModuleFileNameExA Lib "psapi.dll" _
   (ByVal hProcess As Long, ByVal hModule As Long, _
      ByVal ModuleName As String, ByVal nSize As Long) As Long

Private Declare Function EnumProcessModules Lib "psapi.dll" _
   (ByVal hProcess As Long, ByRef lphModule As Long, _
      ByVal cb As Long, ByRef cbNeeded As Long) As Long

Private Const PROCESS_QUERY_INFORMATION = 1024
Private Const PROCESS_VM_READ = 16
Private Const MAX_PATH = 260
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const SYNCHRONIZE = &H100000
'STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &HFFF
Private Const PROCESS_ALL_ACCESS = &H1F0FFF

Private Type PROCESS_MEMORY_COUNTERS
    cb As Long
    PageFaultCount As Long
    PeekWorkingSetSize As Long
    WorkingSetSize As Long
    QuotaPeakPagedPoolUsage As Long
    QuotaPagedPoolUsage As Long
    QuotaPeakNonPagedPoolUsage As Long
    QuotaNonPagedPoolUsage As Long
    PageFileUsage As Long
    PeakPagefileUsage As Long
End Type

Private Declare Function GetProcessMemoryInfo Lib "psapi.dll" _
    (ByVal Process As Long, ByRef ppsmemCounters As PROCESS_MEMORY_COUNTERS, _
    ByVal cb As Long) As Long
#End If

Private Type PROCESSENTRY32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwflags As Long
    szExeFile As String * 260
End Type

Private Declare Function CreateToolhelpSnapshot Lib "kernel32" Alias _
    "CreateToolhelp32Snapshot" (ByVal lFlags As Long, lProcessID As Long) As Long

Private Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" _
    (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long

Private Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" _
    (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long

Private Const TH32CS_SNAPPROCESS As Long = 2&

#If 0 Then
Private Declare Function GetCurrentProcessId Lib "kernel32" () As Long

Public Function EnoughPhysicalMemoryAndImNotTooBig() As Long
    Dim AvailableMemory As Long
    Dim PhysicalMemory As Long

    ' See if we have enough physical memory
    ' return 1 if enough, 0 if not enough, -1 if not supported
    ' First make sure that we're not too big
    If GetVirtMemSizeInMB > 1600 Then
        EnoughPhysicalMemoryAndImNotTooBig = 0                ' We are too big
    Else
        If GetMemoryStats(AvailableMemory, PhysicalMemory) = 1 Then
            If AvailableMemory > 100 Then
                EnoughPhysicalMemoryAndImNotTooBig = 1        ' enough
            Else
                EnoughPhysicalMemoryAndImNotTooBig = 0        ' not enough
            End If
        Else
            EnoughPhysicalMemoryAndImNotTooBig = -1           ' Not supported
        End If
    End If
End Function

Public Function GetVirtMemSizeInMB() As Long
    Dim lngWorkingSet As Long
    Dim lngPageFileUsage As Long
    Dim ll As Long

    ' Get our virtual memory size

    GetMemoryInfo lngWorkingSet, lngPageFileUsage

    ll = 1024
    ll = ll * 1024
    GetVirtMemSizeInMB = lngPageFileUsage / ll
End Function

Public Sub GetMemoryInfo(ByRef lngWorkingSet As Long, ByRef lngPageFileUsage As Long)
    ' lngWorkingSet = MemoryUsage in TaskManager
    ' lngPageFileUsage = VMSize in TaskManager

    Dim hProcess As Long
    Dim pInfo As PROCESS_MEMORY_COUNTERS

    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, GetCurrentProcessId)

    pInfo.cb = LenB(pInfo)

    Call GetProcessMemoryInfo(hProcess, pInfo, LenB(pInfo))

    lngWorkingSet = pInfo.WorkingSetSize
    lngPageFileUsage = pInfo.PageFileUsage

    Call CloseHandle(hProcess)
End Sub
#End If

Public Function TerminateProcessByName(myName As String) As Boolean
    Dim uProcess As PROCESSENTRY32
    Dim rProcessFound As Long
    Dim hSnapshot As Long
    Dim szExename As String
    Dim ExitCode As Long
    Dim myProcess As Long
    Dim AppKill As Boolean
    Dim appCount As Integer
    Dim ii As Integer

    On Local Error GoTo Finish

    appCount = 0
    uProcess.dwSize = Len(uProcess)
    hSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    rProcessFound = ProcessFirst(hSnapshot, uProcess)

    Do While rProcessFound
        ii = InStr(1, uProcess.szExeFile, Chr(0))
        szExename = LCase$(Left$(uProcess.szExeFile, ii - 1))
        If Right$(szExename, Len(myName)) = LCase$(myName) Then
            appCount = appCount + 1
            myProcess = OpenProcess(1&, -1&, uProcess.th32ProcessID)
            AppKill = TerminateProcess(myProcess, 0&)
            Call CloseHandle(myProcess)
        End If
        rProcessFound = ProcessNext(hSnapshot, uProcess)
    Loop
    Call CloseHandle(hSnapshot)
    TerminateProcessByName = (appCount > 0)
    Exit Function

Finish:
    TerminateProcessByName = False
End Function

#If 0 Then
' Count the number of loaders running on this machine

Public Function CountLoadersRunning() As Long
    CountLoadersRunning = CountProcessRunningByName("data loader.exe")
End Function
#End If

#If 0 Then
Public Function CountProcessRunningByName(ProcessName As String) As Integer
    Dim cb                As Long
    Dim cbNeeded          As Long
    Dim lRet              As Long
    Dim NumElements       As Long
    Dim ii                As Long
    Dim hProcess          As Long
    Dim ProcessIDs()      As Long
    Dim Modules(1 To 200) As Long
    Dim cbNeeded2         As Long
    Dim ModuleName        As String
    Dim nSize             As Long
    Dim Count             As Integer
    Dim myProcessName     As String

    cb = 8
    cbNeeded = 96
    myProcessName = LCase(ProcessName)

    ' There is no way to find out how big the passed in array
    ' must be. EnumProcesses() will never return a value in
    ' cbNeeded that is larger than the size of array value
    ' that you passed in the cb parameter.
    '
    ' If cbNeeded == cb upon return, allocate a larger array
    ' and try again until cbNeeded is smaller than cb.

    Do While cb <= cbNeeded
        cb = cb * 2
        ReDim ProcessIDs(cb / 4) As Long
        lRet = EnumProcesses(ProcessIDs(1), cb, cbNeeded)
    Loop

    ' Calculate how many process IDs were returned.

    NumElements = cbNeeded / 4

    For ii = 1 To NumElements

        ' Get a handle to the Process.

        hProcess = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, ProcessIDs(ii))

        ' Iterate through each process with an ID that <> 0.

        If hProcess Then

            ' Get an array of the module handles for the specified process.

            lRet = EnumProcessModules(hProcess, Modules(1), 200, cbNeeded2)

            ' If the Module Array is retrieved, Get the ModuleFileName.

            If lRet <> 0 Then

                ' Fill the ModuleName buffer with spaces.

                ModuleName = Space(MAX_PATH)

                ' Preset buffer size.

                nSize = 500

                ' Get the module file name.

                lRet = GetModuleFileNameExA(hProcess, Modules(1), ModuleName, nSize)

                ' Get the module file name out of the buffer, lRet is how
                ' many characters the string is, the rest of the buffer is spaces.

'@@             If InStr(LCase((ModuleName)), "loader") > 0 Then Stop

                If InStr(LCase(ModuleName), myProcessName) > 0 Then
                    Count = Count + 1
                End If
            End If
        End If

        ' Close the handle to the process.

        CloseHandle hProcess
    Next ii

    CountProcessRunningByName = Count
End Function
#End If
