Attribute VB_Name = "SQLSubs"
Option Explicit

Public Declare Function memcpy_str Lib "release\cfuncs.dll" Alias "_my_memcpy@12" _
  (ByVal dst As Any, ByVal src As Any, ByVal Length As Long) As Long
Public Declare Function memcpy_out Lib "release\cfuncs.dll" Alias "_my_memcpy@12" _
  (ByRef dst As Any, ByVal src As Any, ByVal Length As Long) As Long

#If 0 Then '@@
Private Declare Function strcpy Lib "release\cfuncs.dll" Alias "_MyStrCpy@8" _
  (ByVal dst As Any, ByVal src As Any) As Long
Public Declare Function GetEnv Lib "release\cfuncs.dll" Alias _
  "_MyGetEnv@8" (ByVal Var As String, ByVal TheString As String) As Long
Public Declare Function ReadLine Lib "release\cfuncs.dll" Alias "_ReadLine@12" _
  (ByVal InLine As String, ByVal MaxLen As Long, ByVal FPtr As Long) As Long
#End If

Public Declare Function mysql_init Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal MYSQL As Long) As Long
Public Declare Function mysql_close Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal MYSQL As Long) As Long
Public Declare Function mysql_real_connect Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal MYSQL As Long, ByVal host As String, ByVal User As String, _
  ByVal passwd As String, ByVal db As String, ByVal port As Long, _
  ByVal unix_socket As String, ByVal clientflag As Long) As Long
Public Declare Function mysql_select_db Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal MYSQL As Long, ByVal db As String) As Long
Public Declare Function mysql_query Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal MYSQL As Long, ByVal Query As String) As Long
Public Declare Function mysql_use_result Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal MYSQL As Long) As Long
Public Declare Function mysql_fetch_row Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal Res As Long) As Long
Public Declare Function mysql_num_fields Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal Res As Long) As Long
Public Declare Function mysql_fetch_lengths Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal Res As Long) As Long
Public Declare Function mysql_free_result Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal Res As Long) As Long
Public Declare Function mysql_error Lib "mysql\lib\opt\libmysql.dll" _
  (ByVal MYSQL As Long) As Long

' Support variables for maintaining database connections, etc.

Public LocalMySQLServerAddress As String
Public MySQLPort As Integer

Private MYSQL As Long                   ' (MYSQL *)
Private Res As Long                     ' (RES *)
Private NumFields As Long
Private Row As Long
Private Lengths As Long
Private LengthsList(50) As Long         ' Max cols is 50!
Private Cols(50) As Long                ' Max cols is 50!
Private FieldSpace As String
Private EndOfSet As Boolean
Private CurrentDatabaseName As String
Private FieldInfo As Long

Private AltMYSQL As Long                ' (MYSQL *)
Private AltRes As Long                  ' (RES *)
Private AltNumFields As Long
Private AltRow As Long
Private AltLengths As Long
Private AltLengthsList(50) As Long      ' Max cols is 50!
Private AltCols(50) As Long             ' Max cols is 50!
Private AltFieldSpace As String
Private AltEndOfSet As Boolean
Private AltCurrentDatabaseName As String

Private MySQLDataDirValue As String

Public Sub SQLInitDB(DatabaseToUse As String)
    ' Open direct connect to mysql database

    If MySQLInit <> 0 Then
        If MySQLConnect = 0 Then Exit Sub
        If MySQLSelectDB(DatabaseToUse) <> 0 Then Exit Sub
    End If
End Sub

Public Sub AltSQLInitDB(DatabaseToUse As String)
    ' Open direct connect to mysql database

    If AltMySQLInit <> 0 Then
        If AltMySQLConnect = 0 Then Exit Sub
        If AltSQLSelectDB(DatabaseToUse) <> 0 Then Exit Sub
    End If
End Sub

Public Function SQLSelectDatabase(DatabaseToUse As String) As Long
    SQLSelectDatabase = 1
    If DatabaseToUse = "" Then Exit Function
    If MySQLSelectDB(DatabaseToUse) <> 0 Then Exit Function
    SQLSelectDatabase = 0
End Function

Public Function MySQLInit() As Long
    ' Init the libmysqldll dll. Returns 0 on failure, non 0 on success.

    MYSQL = mysql_init(0)
    MySQLInit = MYSQL
End Function

Public Function MySQLConnect() As Long
    ' Connect to the database. Returns 0 on failure, non 0 on success.

    MYSQL = mysql_real_connect(MYSQL, LocalMySQLServerAddress, _
        SQLUser, SQLPassword, "", MySQLPort, "", 0)

    MySQLConnect = MYSQL

    ' Check for failure to connect here.

    If MYSQL = 0 Then Exit Function
    SQLJustDoIt "Set SQL_BIG_SELECTS = 1"
    SQLJustDoIt "Set MAX_JOIN_SIZE = 2000000000"
End Function

Public Function MySQLSelectDB(DBName As String) As Long
    ' Selects the database. Returns 0 if successful, non zero if error.

    MySQLSelectDB = mysql_select_db(MYSQL, DBName)
    CurrentDatabaseName = DBName
End Function

Public Sub SQLCloseDatabaseConnection()
    ' Close the connection to the database. Returns 1 always.

    If MYSQL <> 0 Then
        mysql_close MYSQL
        MYSQL = 0
    End If
End Sub

Public Function SQLStartQueryWithResults(Command As String) As Boolean
    Dim Stat As Long

    ' Runs the query. Returns non zero if successful, zero if error.

    SQLStartQueryWithResults = True
    EndOfSet = False
    Stat = mysql_query(MYSQL, Command)
    If Stat = 0 Then
        Res = mysql_use_result(MYSQL)
        If Res = 0 Then Exit Function       ' no error, just no results
        NumFields = mysql_num_fields(Res)
        SQLGetNextRow
        Exit Function
    End If

#If 0 Then '@@ save query and error message in some log file
    ' do this for Alt too

    Dim MySQLErrorText As String

    Stat = mysql_error(MYSQL)
    FieldSpace = Space(10000)
    strcpy FieldSpace, Stat
    MySQLErrorText = handle_zero_term(FieldSpace)
#End If

    SQLStartQueryWithResults = False        ' error
End Function

Public Function SQLGetFieldAsString(FieldNumber As Long) As String
    Dim Length As Integer

    ' Get the field from the current row in the results set.
    ' Returns string which is the field.

    If Cols(FieldNumber) <> 0 Then          ' null or empty field
        Length = LengthsList(FieldNumber)
        FieldSpace = Space(Length + 5)
        memcpy_str FieldSpace, Cols(FieldNumber), Length
        SQLGetFieldAsString = Left(FieldSpace, Length)
    Else
        SQLGetFieldAsString = ""
    End If
End Function

Public Function SQLJustDoIt(Command As String) As Boolean
    ' Just run the query.
    ' Returns non zero if successful,  zero if error.

    SQLJustDoIt = SQLStartQueryWithResults(Command)
    If Res <> 0 Then
        While SQLGetNextRow <> 0            ' eat remaining rows
        Wend
    End If
End Function

Public Function SQLGetSingleDatum(Command As String) As String
    ' Get one thing from the database.
    ' Returns the thing.

    SQLGetSingleDatum = ""
    If SQLStartQueryWithResults(Command) Then
        Do While Not SQLAtEndOfSet
            SQLGetSingleDatum = SQLGetFieldAsString(0)
            SQLGetNextRow
        Loop
        SQLQueryClose
    End If
End Function

Public Function SQLGetNextRow() As Long
    ' Get the next row in the result set.
    ' Returns non zero on data, 0 on last row or error.

    SQLGetNextRow = 0
    If EndOfSet = True Then Exit Function

    Row = mysql_fetch_row(Res)
    If Row = 0 Then
        If Res <> 0 Then                    ' only free once
            mysql_free_result Res           ' last row or error: free result set
            Res = 0
        End If
        EndOfSet = True
    Else
        ' copy the array of result pointers into cols.

        memcpy_out Cols(0), Row, NumFields * 4  ' sizeof(long)
        Lengths = mysql_fetch_lengths(Res)
        If Lengths = 0 Then
            EndOfSet = True
        Else
            memcpy_out LengthsList(0), Lengths, NumFields * 4
            EndOfSet = False
            SQLGetNextRow = 1
        End If
    End If
End Function

Public Sub SQLQueryClose()
    While SQLGetNextRow <> 0                ' eat remaining rows
    Wend
End Sub

Public Function SQLAtEndOfSet() As Boolean
    SQLAtEndOfSet = EndOfSet
End Function

Public Function AltMySQLInit() As Long
    AltMYSQL = mysql_init(0)
    AltMySQLInit = AltMYSQL
End Function

Public Function AltMySQLConnect() As Long
    AltMYSQL = mysql_real_connect(AltMYSQL, LocalMySQLServerAddress, _
        SQLUser, SQLPassword, "", MySQLPort, "", 0)

    AltMySQLConnect = AltMYSQL

    ' Check for failure to connect here

    If AltMYSQL = 0 Then Exit Function
    AltMySQLJustDoIt "Set SQL_BIG_SELECTS = 1"
    AltMySQLJustDoIt "Set MAX_JOIN_SIZE = 2000000000"
End Function

Public Function AltSQLSelectDB(DBName As String) As Long
    AltSQLSelectDB = mysql_select_db(AltMYSQL, DBName)
    If AltSQLSelectDB <> 0 Then AltSQLSelectDB = 1
    AltCurrentDatabaseName = DBName
End Function

Public Sub AltSQLCloseDatabaseConnection()
    If AltMYSQL <> 0 Then
        mysql_close AltMYSQL
        AltMYSQL = 0
    End If
End Sub

Public Function AltMySQLJustDoIt(Command As String) As Long
    AltMySQLJustDoIt = AltSQLStartQueryWithResults(Command)
    If AltRes <> 0 Then
        While AltSQLGetNextRow <> 0         ' eat remaining rows
        Wend
    End If
End Function

Public Function AltSQLGetSingleDatum(Command As String) As String
    ' Get one thing from the database.
    ' Returns the thing.

    AltSQLGetSingleDatum = ""
    If AltSQLStartQueryWithResults(Command) Then
        Do While Not AltSQLAtEndOfSet
            AltSQLGetSingleDatum = AltSQLGetFieldAsString(0)
            AltSQLGetNextRow
        Loop
        AltSQLQueryClose
    End If
End Function

Public Function AltSQLStartQueryWithResults(Command As String) As Boolean
    Dim Stat As Long

    AltSQLStartQueryWithResults = True
    AltEndOfSet = False
    Stat = mysql_query(AltMYSQL, Command)
    If Stat = 0 Then
        AltRes = mysql_use_result(AltMYSQL)
        If AltRes = 0 Then Exit Function
        AltNumFields = mysql_num_fields(AltRes)
        AltSQLGetNextRow
        Exit Function
    End If

    AltSQLStartQueryWithResults = False
End Function

Public Function AltSQLGetFieldAsString(FieldNumber As Long) As String
    Dim Length As Integer

    If AltCols(FieldNumber) <> 0 Then       ' null or empty field
        Length = AltLengthsList(FieldNumber)
        AltFieldSpace = Space(Length + 5)
        memcpy_str AltFieldSpace, AltCols(FieldNumber), Length
        AltSQLGetFieldAsString = Left(AltFieldSpace, Length)
    Else
        AltSQLGetFieldAsString = ""
    End If
End Function

Public Function AltSQLGetNextRow() As Long
    AltSQLGetNextRow = 0
    If AltEndOfSet = True Then Exit Function

    AltRow = mysql_fetch_row(AltRes)
    If AltRow = 0 Then
        If AltRes <> 0 Then                 ' only free once
            mysql_free_result AltRes        ' last row or error: free result set
            AltRes = 0
        End If
        AltEndOfSet = True
    Else
        ' copy the array of result pointers into cols

        memcpy_out AltCols(0), AltRow, AltNumFields * 4 ' sizeof(long)
        AltLengths = mysql_fetch_lengths(AltRes)
        If Lengths = 0 Then
            AltEndOfSet = True
        Else
            memcpy_out AltLengthsList(0), AltLengths, AltNumFields * 4
            AltEndOfSet = False
            AltSQLGetNextRow = 1
        End If
    End If
End Function

Public Sub AltSQLQueryClose()
    While AltSQLGetNextRow <> 0             ' eat remaining rows
    Wend
End Sub

Public Function AltSQLAtEndOfSet() As Boolean
    AltSQLAtEndOfSet = AltEndOfSet
End Function

#If 0 Then '@@ NOT CALLED
Public Function MySQLDataDir() As String
    Dim InLine As String
    Dim rFPtr As Long
    Dim s As String

    ' Return the cached value if we've already been here.

    If MySQLDataDirValue <> "" Then
        MySQLDataDir = MySQLDataDirValue
        Exit Function
    End If

    ' Open my.ini.

    MySQLDataDir = ""
    s = Space(1000)
    GetEnv "SYSTEMROOT", s
    rFPtr = fopen(handle_zero_term(s) & "/my.ini", "rb")
    If rFPtr = 0 Then Exit Function

    InLine = Space(1000)

    ' Look for "datadir=".

    Do Until ReadLine(InLine, 990, rFPtr) = 0
        s = handle_zero_term(InLine)
        If Mid(s, 1, Len("datadir=")) = "datadir=" Then
            If Mid(s, Len(s), 1) = vbCr Then s = Mid(s, 1, Len(s) - 1)
            If Mid(s, Len(s), 1) = vbLf Then s = Mid(s, 1, Len(s) - 1)
            If Mid(s, Len(s), 1) = vbCr Then s = Mid(s, 1, Len(s) - 1)
            If Mid(s, Len(s), 1) = vbLf Then s = Mid(s, 1, Len(s) - 1)
            s = Mid(s, Len("datadir=") + 1)
            Exit Do
        End If
    Loop
    fclose rFPtr

    ' Remove beginning and trailing quotes if any.

    If Mid(s, 1, 1) = """" Then s = Mid(s, 2)
    If Mid(s, Len(s), 1) = """" Then s = Mid(s, 1, Len(s) - 1)
    MySQLDataDirValue = s
    MySQLDataDir = s
End Function
#End If

Public Function handle_zero_term(sstr As String) As String
    Dim ii As Integer

    ' Copy the input string, up to the first NULL, into the output string.

    ii = InStr(sstr, vbNullChar)
    If ii <> 0 Then
        handle_zero_term = Left(sstr, ii - 1)
    Else
        handle_zero_term = sstr
    End If
End Function
